<?php  
/*******************************************************************************
--- Dictionnaire des donnes ---


Le dictionnaire des donnes contient tous les champs de la base. 

il est organis en tableau dicField avec deux indices.
indice 1 : nom du champ
indice 2 : fonction.

les fonctions sont : 
comment 	: commentaire, description du champ
default		: valeur par dfaut du champ
type			:	type du champ (non dvelopp)
long			:	longeur du champ (non dvelopp)

Il est utilis en accord avec le dictionnaire des tables (ou MR)
 pour crer les requtes SQL pour la cration de la base de donnes.
 
Ce dictionnaire contient en outre la dfinition des chams de rfrence,
c'est  dire une "norme" de type et longueur selon le thme du champ.
(/ex toutes les cls numriques ont le mme type et la mme longueur,
		 ce qui vite les incohrences de types dans la base.)

NOTES :
pour les cls trangres et le rfrencement des tables les unes par rapport aux
autres, voir le fichier dbRefences.inc
pour les commentaires sur les tables et les champs, voir dbDico.inc
---------------------------------------------------------------- */

/* dicField est un tableau  2 dimensions.
la premire dimension contient le nom du champ, la seconde contient diffrents paramtres :
-	 comment : la description du champ, un commentaire.
-	 default : valeur par dfaut
*/
// type article
$dicField['typACode']['comment'] ="Code type ";
$dicField['typADesc']['comment'] ="Description";
$dicField['typACout']['comment'] ="Cot d'emprunt de ce type";

// type d'emprunt 
$dicField['motifEmpCode']['comment']="Motif d'emprunt"; // commentaire sur la table
$dicField['motifEmpDesc']['comment']='Description'; // champ descriptif des enreg
$dicField['motifEmpGroupe']['comment']='Emprunt pour un groupe ou individuel'; // champ descriptif des enreg

// Article 
$dicField['artNum']['comment']="Numro"; // commentaire sur la table
$dicField['artDesc']['comment']="Description"; // commentaire sur la table
$dicField['artSto']['comment']="Stock courant"; // commentaire sur la table
$dicField['artSto']['default']=1; // Valeur par dfaut du champ
$dicField['artStoMax']['comment']="Stock Maximum (si 1 article gr  la pice)"; // commentaire sur la table
$dicField['artStoMax']['default']=1; // Valeur par dfaut du champ
$dicField['artGesType']['comment']="Type de gestion"; // commentaire sur la table
$dicField['artRev1']['comment']="Date de rvision niveau 1"; // commentaire sur la table
$dicField['artRev2']['comment']="Date de rvision n2"; // commentaire sur la table
$dicField['tyACode']['comment']="Code type Article"; // commentaire sur la table

// Plongeur
$dicField['ploNum']['comment']="n du plongeur"; // commentaire sur la table
$dicField['ploCode']['comment']="n du plongeur"; // commentaire sur la table
$dicField['ploNom']['comment']="Nom"; // commentaire sur la table
$dicField['ploPrenom']['comment']="Prnom"; // commentaire sur la table
$dicField['ploAdr']['comment']="Adresse"; // commentaire sur la table
$dicField['ploCompte']['comment']="Compte d'emprunt"; // commentaire sur la table

// Emprunt 
$dicField['typECode']['comment']="Type d'emprunt"; // commentaire sur la table
$dicField['empDateSortie']['comment']="date d'emprunt"; // commentaire sur la table
$dicField['empDateRetour']['comment']='date de retour'; // champ descriptif des enreg
$dicField['empQt']['comment']='Quantit emprunte'; // champ descriptif des enreg
$dicField['empCode']['comment']='Statut emprunt'; // champ descriptif des enreg

// donnes de base : tableaux contenant : type, null ou non, valeur par dfaut, 
/*
$dicFieldBase['clNumrique']=array("int(6)", "Non", "");
$dicFieldBase['clCode']=array("varchar(6)", "Non", "");
$dicFieldBase['nom']=array("varchar(50)", "Non", "");
$dicFieldBase['nomCourt']=array("varchar(30)", "Non", "");
$dicFieldBase['nomDouble']=array("varchar(100)", "Non", "");
$dicFieldBase['nomTriple']=array("varchar(150)", "Non", "");
$dicFieldBase['date']=array("dateTime", "Non", 0000-00-00 00:00:00);
$dicFieldBase['prix']=array("float(8,2)", "Non", 0.00);
$dicFieldBase['Devise']=array("char(3)", "Non", "EUR");
$dicFieldBase['numroCourt1']=array("int(3)", "Non", 1);

// donnes lmentaires
$dicField['autDDeces'] =$dicFieldBase['date'];
$dicField['autDNaiss'] =$dicFieldBase['date'];
$dicField['autNom']		 =$dicFieldBase['nom'];
$dicField['autNum']		 =$dicFieldBase['clNumrique'];
$dicField['docCode']	 =$dicFieldBase['clCode'];
$dicField['docCote']	 =$dicFieldBase['prix'];
$dicField['docCover']	 =$dicFieldBase['nomCourt'];
$dicField['docDachat'] =$dicFieldBase['date'];
$dicField['docDevise'] =$dicFieldBase['Devise'];
$dicField['docNum']		 =$dicFieldBase['clNumrique'];
$dicField['docPrix']	 =$dicFieldBase['prix'];
$dicField['docTitre']	 =$dicFieldBase['nomDouble'];
$dicField['docTomeNum']=$dicFieldBase['numroCourt1'];
$dicField['edtCode']	 =$dicFieldBase['clCode'];
$dicField['edtNum']		 =$dicFieldBase['clNumrique'];
$dicField['edtNumDft'] =$dicFieldBase['clNumrique'];
$dicField['genCode']	 =$dicFieldBase['clCode'];
$dicField['genDesc']	 =$dicFieldBase['nomCourt'];
$dicField['genNum']		 =$dicFieldBase['clNumrique'];
$dicField['genTxt']		 =$dicFieldBase['nomTriple'];
$dicField['grp_grpNum']=$dicFieldBase['clNumrique'];
$dicField['grpCode']   =$dicFieldBase['clCode'];
$dicField['grpNom']		 =$dicFieldBase['nom'];
$dicField['grpNum']		 =$dicFieldBase['clNumrique'];
$dicField['grpType']	 =array("enum('collection', 'serie')", "Non", "collection");
$dicField['magAdr']		 =$dicFieldBase['nomTriple'];
$dicField['magCode']	 =$dicFieldBase['clCode'];
$dicField['magNom']		 =$dicFieldBase['nomCourt'];
$dicField['magNum']		 =$dicFieldBase['clNumrique'];
$dicField['medCode']	 =$dicFieldBase['clCode'];
$dicField['medDesc']	 =$dicFieldBase['nomTriple'];
$dicField['medNum']		 =$dicFieldBase['clNumrique'];
$dicField['metCode']	 =$dicFieldBase['clCode'];
$dicField['metDesc']	 =$dicFieldBase['nomTriple'];
$dicField['metNum']		 =$dicFieldBase['clNumrique'];
$dicField['styCode']	 =$dicFieldBase['clCode'];
$dicField['styDesc']	 =$dicFieldBase['nomCourt'];
$dicField['styNum']		 =$dicFieldBase['clNumrique'];
$dicField['styTxt']		 =$dicFieldBase['nomTriple'];
$dicField['tomeNum']	 =$dicFieldBase['numroCourt1'];
$dicField['txtNum']		 =$dicFieldBase['clNumrique'];
*/?>  
