-- Données de contexte
-- BDD version 1.0.0 ou plus
--
SET SQL_MODE="NO_AUTO_VALUE_ON_ZERO";
SET time_zone = "+00:00";


-- /*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
-- /*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
-- /*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
-- /*!40101 SET NAMES utf8 */;

-- Base de données: `erp`
-- 
use erp;

-- --------------------------------------------------------
-- Vidage des tables du contexte, avant insertion
-- 	ATTENTION, ne pas changer l'ordre des tables, il y a des dépendances de référence (clés étrangères)
-- --------------------------------------------------------
delete FROM `cptajournal` ;
delete FROM `stockmvt` ;
delete FROM `panierarticle` ;
delete FROM `panier` ;
delete FROM `lignecdefourart` ;
delete FROM `cdefour` ;
delete FROM `lignecdeclientart` ;
delete FROM `cdeclient` ;
delete FROM `ordfab` ;
delete FROM `ofnomenclature` ;
delete FROM `ofgamme` ;
delete FROM `artnomenclature` ;
delete FROM `artgamme` ;
delete FROM `article` ;
delete FROM `tier` ;
delete FROM `artcategorie` ;
delete FROM `param` WHERE parmCode not like 'SOC%' and parmCode <> 'TVA';
-- --------------------------------------------------------
-- Remplissage des tables pour le contexte Ski
-- 	ATTENTION, ne pas changer l'ordre des tables, il y a des dépendances de référence (clés étrangères)
-- --------------------------------------------------------
-- Contenu de la table `param`
UPDATE `param` SET  `parmValue`=0, `parmText`='Test & Co' WHERE `parmCode`= 'SOCNOM';
UPDATE `param` SET  `parmValue`=0, `parmText`='X rue des Essais' WHERE `parmCode`= 'SOCADR';
UPDATE `param` SET  `parmValue`=0, `parmText`='12345' WHERE `parmCode`= 'SOCCP';
UPDATE `param` SET  `parmValue`=0, `parmText`='TESTTEST' WHERE `parmCode`= 'SOCVIL';
UPDATE `param` SET  `parmValue`=12345678, `parmText`='12 345 678€' WHERE `parmCode`= 'SOCCAP';
UPDATE `param` SET  `parmValue`=0, `parmText`='123456789 12341' WHERE `parmCode`= 'SOCSIR';

-- Contenu de la table `artcategorie` ; catVente : 1=peut être vendu, 0=non vendu
INSERT INTO `artcategorie` (`code`, `libelle`, `catVente`) VALUES
('ACC', 'Accessoires', '1'),
('ACP', 'Accessoires de production', '0'),
('CSM', 'Consommables de production', '1'),
('DIV', 'Divers', '0'),
('FP1', 'Famille prod 1', '0'),
('FP2', 'Famille Prod 2', '0'),
('FP3', 'Famille Prod 3', '0'),
('FP4', 'Famille Prod 4', '0'),
('FP5', 'Famille Prod 5', '0'),
('FP6', 'Famille Prod 6', '0');

-- --------------------------------------------------------
-- Contenu de la table `tier`
INSERT INTO `tier` (`tierNum`, `tierRaisonSociale`, `tierAdresse`, `paysCode`, `tierRemiseTier`, `tierLogin`, `tierMot2Pass`, `tierTypeCode`, `tierPayCode`, `tierDelai`) VALUES
(1, 'Alpha Amandine', '32 Route de Strasbourg 68000 Colmar', 'FRA', NULL, '', '', 'c', 0, 0),
(2, 'Bravo Bernard', '23 Route de Colmar, 67000 Strasbourg', 'FRA', NULL, '', '', 'c', 0, 0),
(3, 'Charlie Corinne', '22 Quai de Paris, 67000 Strasbourg', 'FRA', NULL, '', '', 'c', 0, 0),
(4, 'Delta Damien', '33 Haupt Strasse, D-77671 Kehl', 'GER', NULL, '', '', 'c', 0, 0),
(5, 'Echo Echo, ...', '123 rue de la montagne\r\nSélénia', 'AND', NULL, 'azure ski club', 'dddb2856eb87d5c4e21e41f1318de846300030df', 'c', 0, 0),
(6, 'Fox-trot Frank', '123 rue de la montagne\r\nSélénia', 'AND', NULL, 'Azure ski club', 'ba174ca63ffe106338f39d6542dddfe909e0a0ad', 'c', 0, 0),
(7, 'GOLF de Gérard', '21 rue saint joseph, S-2536 Oslo', 'AND', NULL, 'a', '86f7e437faa5a7fce15d1ddcb9eaeaea377667b8', 'c', 0, 0),
(8, 'Hôtel Henri', 'hici hou làh', 'AND', NULL, 'Hôtel Henri', '70f6187323c23d92c167860619b542def67a5cb7', 'c', 0, 0),
(9, 'Hôtel Henri', 'hici hou làh', 'AND', NULL, 'Hôtel Henri', '70f6187323c23d92c167860619b542def67a5cb7', 'c', 0, 0),
(10, 'Indiana Inoac', 'ici et là', 'AND', NULL, 'Indiana Inoac', 'ec09f75f17da702178caeb20eaaf3e31b90c91a6', 'c', 0, 0),
(11, 'Juliette Fournitures 1', 'Chez adresse du Fournisseur 1', 'FRA', NULL, 'four1', 'four1', 'f', 0, 0),
(12, 'Kilo Négoce Fournitures 2', 'Chez adresse du Fournisseur 2', 'FRA', NULL, 'four2', 'four2', 'f', 0, 2880),
(13, 'Lima services Four 3', 'Chez adresse du Fournisseur 3', 'FRA', NULL, 'four3', 'four3', 'f', 0, 2175);

-- --------------------------------------------------------
-- Contenu de la table `article`
INSERT INTO `article` (`artCode`, `artDesc`, `artPrixHT`, `stockInit`, `stockDate`, `artTypeCode`, `artCatCode`, `artVendu`, `artAddMode`, `artPlanif`, `artStockMini`, `artLotMini`, `artMultipleLotMini`) VALUES
('C001', 'Consommable 001', 6.10000, 0.00, '2014-12-01', 'C', '', '1', '0', 'S', 50, 0.00, 0.00),
('C002', 'consommable 002', 6.20000, 0.00, '2014-12-01', 'C', '', '1', '0', 'S', 10, 0.00, 0.00);
INSERT INTO `article` (`artCode`, `artDesc`, `artPrixHT`, `stockInit`, `stockDate`, `artTypeCode`, `artCatCode`, `artVendu`, `artAddMode`, `artPlanif`, `artStockMini`, `artLotMini`, `artMultipleLotMini`) VALUES
('MP001', 'MP001 pour PF001', 9.00000, 0.00, '2014-12-01', 'M', '', '1', '0', 'S', 10, 0.00, 0.00),
('MP002', 'MP002 pour PF002', 8.00000, 0.00, '2014-12-01', 'M', '', '1', '0', 'S', 10, 0.00, 0.00),
('MP003', 'MP003 pour PF003', 8.30000, 0.00, '2014-12-01', 'M', '', '1', '0', 'S', 10, 0.00, 0.00),
('MP004', 'MP004 pour PF003, PF004', 8.40000, 0.00, '2014-12-01', 'M', '', '1', '0', 'S', 10, 0.00, 0.00),
('MP005', 'MP005 pour PF004', 8.50000, 0.00, '2014-12-01', 'M', '', '1', '0', 'S', 10, 0.00, 0.00),
('MP006', 'MP006 non utilisée', 8.60000, 0.00, '2014-12-01', 'M', '', '1', '0', 'S', 10, 0.00, 0.00),
('MP014', 'Matière 014', 0.00000, 0.00, '2014-12-01', 'M', '', '1', '0', 'S', 10, 0.00, 0.00),
('MP015', 'Matière 015', 0.00000, 0.00, '2014-12-01', 'M', '', '1', '0', 'S', 10, 0.00, 0.00),
('MP111', 'MP111 pour S111', 7.10000, 0.00, '2014-12-01', 'M', '', '1', '0', 'S', 10, 0.00, 0.00),
('MP211', 'MP211 pour S211 et S212', 7.20000, 0.00, '0000-00-00', 'M', '', '1', '0', 'S', 10, 0.00, 0.00),
('MP302', 'MP302 pour PF302', 0.00000, 0.00, '2014-12-01', 'M', '', '1', '0', 'S', 5, 0.00, 0.00),
('MP311', 'MP311 pour S311', 0.00000, 0.00, '2014-12-01', 'M', '', '1', '0', 'S', 5, 0.00, 0.00),
('MP401', 'MP401 pour PF401', 0.00000, 0.00, '2014-12-01', 'M', '', '1', '0', 'S', 5, 0.00, 0.00),
('MP411', 'MP411 pour S411', 0.00000, 0.00, '2014-12-01', 'M', '', '1', '0', 'S', 5, 0.00, 0.00),
('MP421', 'MP421 pour S421', 0.00000, 0.00, '2014-12-01', 'M', '', '1', '0', 'S', 5, 0.00, 0.00),
('MP422', 'MP422 pour S421', 0.00000, 0.00, '2014-12-01', 'M', '', '1', '0', 'S', 5, 0.00, 0.00);
INSERT INTO `article` (`artCode`, `artDesc`, `artPrixHT`, `stockInit`, `stockDate`, `artTypeCode`, `artCatCode`, `artVendu`, `artAddMode`, `artPlanif`, `artStockMini`, `artLotMini`, `artMultipleLotMini`) VALUES
('NEG001', 'Article négoce 001', 10.00000, 0.00, '0000-00-00', 'N', '', '1', '0', 'S', 5, 0.00, 0.00),
('NEG002', 'Article négoce 002', 11.00000, 7.00, '0000-00-00', 'N', '', '1', '0', 'S', 5, 0.00, 0.00);
INSERT INTO `article` (`artCode`, `artDesc`, `artPrixHT`, `stockInit`, `stockDate`, `artTypeCode`, `artCatCode`, `artVendu`, `artAddMode`, `artPlanif`, `artStockMini`, `artLotMini`, `artMultipleLotMini`) VALUES
('PF001', 'PF001, utilise MP001', 4.10000, 0.00, '2014-12-01', 'F', '', '0', '1', 'S', 5, 0.00, 0.00),
('PF002', 'PF002, utilise MP002', 4.20000, 0.00, '2014-12-01', 'F', '', '0', '1', 'S', 5, 0.00, 0.00),
('PF003', 'PF003, utilise MP003 et MP004', 4.30000, 0.00, '2014-12-01', 'F', '', '0', '1', 'S', 5, 0.00, 0.00),
('PF004', 'PF004, utilise MP004 et MP005', 4.40000, 0.00, '2014-12-01', 'F', '', '1', '1', 'S', 5, 0.00, 0.00),
('PF101', 'PF101, utilise S111', 10.10000, 0.00, '2014-12-01', 'F', '', '0', '1', 'S', 5, 0.00, 0.00),
('PF201', 'PF201, utilise S211', 10.20000, 0.00, '2014-12-01', 'F', '', '0', '1', 'S', 5, 0.00, 0.00),
('PF202', 'PF202, utilise S211', 10.30000, 0.00, '2014-12-01', 'F', '', '0', '1', 'S', 5, 0.00, 0.00),
('PF301', 'Produit fini 301', 0.00000, 0.00, '2014-12-01', 'F', '', '0', '1', 'S', 5, 0.00, 0.00),
('PF302', 'PF302, utilise MP302 & S311', 0.00000, 0.00, '2014-12-20', 'F', '', '0', '1', 'S', 5, 0.00, 0.00),
('PF401', 'PF401, utilise S411 & MP401', 0.00000, 0.00, '2014-12-01', 'F', '', '0', '1', 'S', 5, 0.00, 0.00);
INSERT INTO `article` (`artCode`, `artDesc`, `artPrixHT`, `stockInit`, `stockDate`, `artTypeCode`, `artCatCode`, `artVendu`, `artAddMode`, `artPlanif`, `artStockMini`, `artLotMini`, `artMultipleLotMini`) VALUES
('S111', 'SF111 pour PF101', 0.00000, 0.00, '2014-12-01', 'S', '', '1', '1', 'S', 5, 0.00, 0.00),
('S211', 'SF201 pour PF201', 0.00000, 0.00, '2014-12-01', 'S', '', '1', '1', 'S', 5, 0.00, 0.00),
('S212', 'SF202 pour PF202', 0.00000, 0.00, '2014-12-01', 'S', '', '1', '1', 'S', 5, 0.00, 0.00),
('S311', 'S311 pour PF301 & PF302', 0.00000, 0.00, '2014-12-01', 'S', '', '1', '1', 'S', 5, 0.00, 0.00),
('S411', 'SF411 pour PF401', 0.00000, 0.00, '2014-12-01', 'S', '', '1', '1', 'S', 5, 0.00, 0.00),
('S421', 'S421 pour S411, utilise MP421 & 422', 0.00000, 0.00, '2014-12-20', 'S', '', '1', '1', 'S', 0, 0.00, 0.00);

-- --------------------------------------------------------
-- Contenu de la table `artgamme`
INSERT INTO `artgamme` (`artCode`, `opNum`, `opDesc`, `opDuree`, `opUniteTemps`) VALUES
('PF001', 100, 'transformation MP en PF Etape 1', 10, 'm'),
('PF001', 900, 'Transformation finale (emballage)', 19, 'm'),
('PF002', 100, 'transformation MP en PF Etape 1', 10, 'm'),
('PF002', 900, 'Transformation finale (emballage)', 19, 'm'),
('PF003', 100, 'transformation MP en PF Etape 1', 10, 'm'),
('PF003', 900, 'Transformation finale (emballage)', 19, 'm'),
('PF004', 100, 'transformation MP en PF Etape 1', 10, 'm'),
('PF004', 900, 'Transformation finale (emballage)', 19, 'm'),
('PF101', 100, 'transformation Etape 1', 10, 'm'),
('PF101', 900, 'Transformation finale', 19, 'm'),
('PF201', 100, 'transformation Etape 1', 10, 'm'),
('PF201', 900, 'Transformation finale', 19, 'm'),
('PF301', 100, 'transformation Etape 1', 10, 'm'),
('PF301', 900, 'Transformation finale', 19, 'm'),
('PF302', 100, 'transformation Etape 1', 10, 'm'),
('PF302', 900, 'Transformation finale', 19, 'm'),
('PF401', 100, 'transformation Etape 1', 10, 'm'),
('PF401', 900, 'Transformation finale', 19, 'm'),
('S111', 100, 'transformation Etape 1', 10, 'm'),
('S111', 900, 'Transformation finale', 19, 'm'),
('S211', 100, 'transformation Etape 1', 10, 'm'),
('S211', 900, 'Transformation finale', 19, 'm'),
('S311', 100, 'transformation Etape 1', 10, 'm'),
('S311', 900, 'Transformation finale', 19, 'm'),
('S411', 100, 'transformation Etape 1', 10, 'm'),
('S411', 900, 'Transformation finale', 19, 'm'),
('S421', 100, 'transformation Etape 1', 10, 'm'),
('S421', 900, 'Transformation finale', 19, 'm');

-- --------------------------------------------------------
-- Contenu de la table `artnomenclature`
INSERT INTO `artnomenclature` (`artCode`, `comp_artCode`, `opNum`, `compQte`) VALUES
('PF001', 'MP001', 100, 1),
('PF002', 'MP002', 100, 2),
('PF003', 'MP003', 100, 1),
('PF003', 'MP004', 0, 1),
('PF004', 'MP004', 0, 1),
('PF004', 'MP005', 0, 1),
('PF101', 'S111', 0, 1),
('PF201', 'S211', 0, 1),
('PF202', 'S212', 0, 1),
('PF301', 'S311', 0, 1),
('PF302', 'MP302', 0, 1),
('PF302', 'S311', 0, 1),
('PF401', 'MP401', 0, 1),
('PF401', 'S411', 0, 1),
('S111', 'MP111', 0, 1),
('S211', 'MP211', 0, 1),
('S212', 'MP211', 0, 1),
('S311', 'MP311', 0, 1),
('S411', 'MP411', 0, 1),
('S411', 'S421', 0, 1),
('S421', 'MP421', 0, 1),
('S421', 'MP422', 0, 1);

-- --------------------------------------------------------
-- Contenu de la table `ordfab`
INSERT INTO `ordfab` (`ofNum`, `artCode`, `ofQte`, `ofQteFab`, `ofDateDeb`, `ofDateFin`, `ofDateType`, `ofDuree`, `ofUniteTemps`, `ofEtat`) VALUES
(4, 'PF001',20, 0, DATE_SUB(CURDATE(), INTERVAL 2 DAY), DATE_SUB(CURDATE(), INTERVAL 01 DAY), 'L', 580, 'm', 1),
(5, 'S421', 20, 0, DATE_SUB(CURDATE(), INTERVAL 1 DAY), DATE_SUB(CURDATE(), INTERVAL 01 DAY), 'L', 580, 'm', 1);

-- --------------------------------------------------------
-- Contenu de la table `ofgamme`
INSERT INTO `ofgamme` (`ofNum`, `opNum`, `opDateDeb`, `opDateFin`, `opDureeReelle`, `opUniteTemps`, `opQteFinie`, `opQteRejetee`, `opEtat`) VALUES
(4, 100, DATE_SUB(CURDATE(), INTERVAL 01 DAY), DATE_SUB(CURDATE(), INTERVAL 01 DAY), 200, 'm', 0, 0, 0),
(4, 900, DATE_SUB(CURDATE(), INTERVAL 01 DAY), DATE_SUB(CURDATE(), INTERVAL 01 DAY), 380, 'm', 0, 0, 0),
(5, 100, DATE_SUB(CURDATE(), INTERVAL 01 DAY), DATE_SUB(CURDATE(), INTERVAL 01 DAY), 200, 'm', 0, 0, 0),
(5, 900, DATE_SUB(CURDATE(), INTERVAL 01 DAY), DATE_SUB(CURDATE(), INTERVAL 01 DAY), 380, 'm', 0, 0, 0);

-- --------------------------------------------------------
-- Contenu de la table `ofnomenclature`
INSERT INTO `ofnomenclature` (`ofNum`, `ofComp_artCode`, `opNum`, `ofQteTheo`, `ofQteConsommee`) VALUES
(4, 'MP001', 0, 20, 0),
(5, 'MP421', 0, 20, 0),
(5, 'MP422', 0, 20, 0);

-- --------------------------------------------------------
-- Contenu de la table `cdeclient` ; statut : 0=ferme, 4=prev, etat : 0=devis, 1=cde, 3=livree, 4=facturee, 6=done, 9=del;
INSERT INTO `cdeclient` (`cdeNum`, `cdeDate`, `cliNum`, `cdeRemiseGlobale`, `transCode`, `paiemtCode`, `cdeStatut`, `cdeEtat`) VALUES
(1, DATE_SUB(CURDATE(), INTERVAL 15 DAY), 1, 0, 1, 1, 0, 1),
(2, DATE_SUB(CURDATE(), INTERVAL 13 DAY), 1, 0, 1, 1, 0, 1),
(3, DATE_SUB(CURDATE(), INTERVAL 10 DAY), 1, 0, 5, 3, 0, 1),
(4, DATE_SUB(CURDATE(), INTERVAL 10 DAY), 2, 0, 5, 3, 0, 1),
(5, DATE_SUB(CURDATE(), INTERVAL 10 DAY), 3, 0, 5, 3, 0, 1),
(6, DATE_SUB(CURDATE(), INTERVAL 09 DAY), 4, 0, 5, 3, 0, 1),
(7, DATE_SUB(CURDATE(), INTERVAL 08 DAY), 5, 0, 4, 3, 0, 1),
(8, DATE_SUB(CURDATE(), INTERVAL 06 DAY), 6, 0, 4, 3, 0, 1),
(9, DATE_SUB(CURDATE(), INTERVAL 06 DAY), 7, 0, 4, 3, 0, 1),
(10, DATE_SUB(CURDATE(), INTERVAL 01 DAY), 8, 0, 4, 3, 0, 1),
(13, DATE_SUB(CURDATE(), INTERVAL 01 DAY), 8, 0, 4, 3, 0, 1);

-- ---------------------------------------------------------- --------------------------------------------------------
-- Contenu de la table `lignecdeclientart`
INSERT INTO `lignecdeclientart` (`cdeNum`, `artCode`, `qte`, `qteShipped`, `qteInvoiced`, `ligneRemiseArticle`, `ligneEtat`) VALUES
(1, 'PF001', 1, 0, 0, 0, 1),	(1, 'PF002', 1, 0, 0, 0, 1),	(1, 'PF003', 1, 0, 0, 0, 1),	(1, 'PF004', 1, 0, 0, 0, 1),
(2, 'PF001', 2, 0, 0, 0, 1),	(2, 'PF002', 2, 0, 0, 0, 1),	(2, 'PF003', 2, 0, 0, 0, 1),	(2, 'PF004', 2, 0, 0, 0, 1),
(3, 'PF001', 3, 0, 0, 0, 1),	(3, 'PF002', 3, 0, 0, 0, 1),	(3, 'PF003', 3, 0, 0, 0, 1),	(3, 'PF004', 3, 0, 0, 0, 1),	
(4, 'PF001', 4, 0, 0, 0, 1),	(4, 'PF101', 4, 0, 0, 0, 1),	
(5, 'PF101', 5, 0, 0, 0, 1),	(5, 'PF201', 5, 0, 0, 0, 1),	(5, 'PF202', 5, 0, 0, 0, 1),
(6, 'PF301', 6, 0, 0, 0, 1),	(6, 'PF302', 6, 0, 0, 0, 1),
(7, 'PF401', 7, 0, 0, 0, 1),
(8, 'PF401', 8, 0, 0, 0, 1),
(9, 'NEG001', 1, 0, 0, 0, 1),	(9, 'NEG002', 1, 0, 0, 0, 1),	(9, 'PF401', 9, 0, 0, 0, 1);
(10, 'NEG001', 1, 0, 0, 0, 1),	(10, 'NEG002', 1, 0, 0, 0, 1),	(10, 'PF001', 1, 0, 0, 0, 1),	(10, 'PF002', 1, 0, 0, 0, 1),
(13, 'NEG001', 1, 0, 0, 0, 1),	(13, 'PF001', 1, 0, 0, 0, 1),	(13, 'PF002', 1, 0, 0, 0, 1);	
-- --------------------------------------------------------
-- Contenu de la table `cdefour`
-- 11 cdes pour le founisseur 11 (de j-5 à j+5, 3 articles, toutes à recevoir
--  5 cdes pour le founisseur 12 (de j-2 à j+2, 1 article, le même que celui du 1er fournisseur,
--  6 cdes pour le founisseur 13 (de j-2 à j+2, certaines sont au même jour (aujourd hui, d autres sont déjà reçues, partiellement ou complètement)
INSERT INTO `cdefour` (`cdeNum`, `cdeDate`, `fourNum`, `cdeEtat`) VALUES
(1,  DATE_SUB(CURDATE(), INTERVAL 5 DAY), 11, 1),
(2,  DATE_SUB(CURDATE(), INTERVAL 4 DAY), 11, 1),
(3,  DATE_SUB(CURDATE(), INTERVAL 3 DAY), 11, 1),
(4,  DATE_SUB(CURDATE(), INTERVAL 2 DAY), 11, 1),
(5,  DATE_SUB(CURDATE(), INTERVAL 1 DAY), 11, 1),
(6,  CURDATE(),                           11, 1),
(7,  DATE_ADD(CURDATE(), INTERVAL 1 DAY), 11, 1),
(8,  DATE_ADD(CURDATE(), INTERVAL 2 DAY), 11, 1),
(9,  DATE_ADD(CURDATE(), INTERVAL 3 DAY), 11, 1),
(10, DATE_ADD(CURDATE(), INTERVAL 4 DAY), 11, 1),
(11, DATE_ADD(CURDATE(), INTERVAL 5 DAY), 11, 1),
(12, DATE_SUB(CURDATE(), INTERVAL 3 DAY), 12, 2),
(13, DATE_SUB(CURDATE(), INTERVAL 2 DAY), 12, 2),
(14, DATE_SUB(CURDATE(), INTERVAL 1 DAY), 12, 1),
(15, CURDATE()						  	, 12, 2),
(16, DATE_ADD(CURDATE(), INTERVAL 2 DAY), 12, 2),
(17, CURDATE(), 						  13, 2),
(18, DATE_SUB(CURDATE(), INTERVAL 2 DAY), 13, 1),
(19, DATE_SUB(CURDATE(), INTERVAL 1 DAY), 13, 1),
(20, CURDATE(), 						  13, 2),
(21, DATE_ADD(CURDATE(), INTERVAL 1 DAY), 13, 1),
(22, DATE_ADD(CURDATE(), INTERVAL 2 DAY), 13, 1);
-- --------------------------------------------------------
-- Contenu de la table `lignecdefourart`
INSERT INTO `lignecdefourart` (`cdeNum`, `artCode`, `qte`, `qteRecieved`, `ligneRemiseArticle`, `ligneEtat`) VALUES
(1,  'NEG001', 5, 0, 0, 1), (1,  'NEG002', 3, 0, 0, 1), (1,  'MP001', 3, 0, 0, 1),
(2,  'NEG001', 5, 0, 0, 1), (2,  'NEG002', 3, 0, 0, 1), (2,  'MP001', 3, 0, 0, 1),
(3,  'NEG001', 5, 0, 0, 1), (3,  'NEG002', 3, 0, 0, 1), (3,  'MP001', 3, 0, 0, 1),
(4,  'NEG001', 5, 0, 0, 1), (4,  'NEG002', 3, 0, 0, 1), (4,  'MP001', 3, 0, 0, 1),
(5,  'NEG001', 5, 0, 0, 1), (5,  'NEG002', 3, 0, 0, 1), (5,  'MP001', 3, 0, 0, 1),
(6,  'NEG001', 5, 0, 0, 1), (6,  'NEG002', 3, 0, 0, 1), (6,  'MP001', 3, 0, 0, 1),
(7,  'NEG001', 5, 0, 0, 1), (7,  'NEG002', 3, 0, 0, 1), (7,  'MP001', 3, 0, 0, 1),
(8,  'NEG001', 5, 0, 0, 1), (8,  'NEG002', 3, 0, 0, 1), (8,  'MP001', 3, 0, 0, 1),
(9,  'NEG001', 5, 0, 0, 1), (9,  'NEG002', 3, 0, 0, 1), (9,  'MP001', 3, 0, 0, 1),
(10, 'NEG001', 5, 0, 0, 1), (10, 'NEG002', 3, 0, 0, 1), (10, 'MP001', 3, 0, 0, 1),
(11, 'NEG001', 5, 0, 0, 1), (11, 'NEG002', 3, 0, 0, 1), (11, 'MP001', 3, 0, 0, 1),
(12, 'NEG001', 3, 0, 0, 1), (12, 'NEG002', 3, 0, 0, 1), (12, 'MP001', 3, 3, 0, 2),
(13, 'NEG001', 3, 5, 0, 2), (14, 'NEG001', 5, 0, 0, 1), (15, 'MP001', 5, 5, 0, 2), (16, 'MP002', 5, 5, 0, 2),
(17, 'NEG001', 5, 5, 0, 2), (17, 'NEG002', 5, 5, 0, 2),
(18, 'NEG001', 5, 1, 0, 1), (18, 'NEG002', 5, 1, 0, 1),
(19, 'NEG001', 5, 5, 0, 2), (19, 'NEG002', 5, 0, 0, 1),
(19, 'NEG001', 5, 0, 0, 1), (20, 'NEG002', 5, 5, 0, 2),
(21, 'NEG001', 5, 0, 0, 1), (21, 'NEG002', 3, 0, 0, 1), (21, 'MP001', 3, 0, 0, 1),
(22, 'NEG001', 5, 0, 0, 1), (22, 'NEG002', 3, 0, 0, 1), (22, 'MP001', 3, 0, 0, 1), (22, 'MP002', 3, 0, 0, 1), (22, 'MP003', 3, 0, 0, 1), (22, 'MP004', 3, 0, 0, 1);
-- --------------------------------------------------------
-- Contenu de la table `panier`
INSERT INTO `panier` (`panierId`, `panierDate`, `invNom`, `invAdress`, `invPaysCode`, `invMail`, `invTel`, `delIsInv`, `delNom`, `delAdress`, `delPaysCode`, `delMail`, `delTel`, `payMode`, `transMode`, `tierNum`, `cdeNum`, `status`) VALUES
('OIiZXKtnwfdEXOTevIkUgKmZOfmPrRAEXSYWYRYE', '2014-12-28 17:11:54', 'Indiana Inoac', 'ici', 'AND', '', '', '', '', '', '', '', '', 3, 4, 11, 13, 2),
('RkWxSDRgVtUEOAZrOGHOQhHvVkRXIdqOQDnILkZu', '2014-12-28 15:09:40', 'Hôtel Henri', 'hici hou làh', 'AND', '', '', '', '', '', '', '', '', 3, 4, 10, 10, 2),
('sZMRtHrThnMSdquLsPrCYqPCDnIRY0MLGHXIsqIK', '2015-03-13 09:59:24', 'GOLF de Gérard', '21 rue saint joseph, S-2536 Oslo', 'AND', '', '', '', '', '', '', '', '', 3, 4, 0, 0, 0);
-- --------------------------------------------------------
-- Contenu de la table `panierarticle`
INSERT INTO `panierarticle` (`panierId`, `artCode`, `panierQty`, `panierDate`, `status`) VALUES
('OIiZXKtnwfdEXOTevIkUgKmZOfmPrRAEXSYWYRYE', 'NEG001', 1.00, '2014-12-28 17:12:09', 2),
('OIiZXKtnwfdEXOTevIkUgKmZOfmPrRAEXSYWYRYE', 'PF001', 1.00, '2014-12-28 17:11:54', 2),
('OIiZXKtnwfdEXOTevIkUgKmZOfmPrRAEXSYWYRYE', 'PF002', 1.00, '2014-12-28 17:12:01', 2),
('RkWxSDRgVtUEOAZrOGHOQhHvVkRXIdqOQDnILkZu', 'NEG001', 1.00, '2014-12-28 15:09:40', 2),
('RkWxSDRgVtUEOAZrOGHOQhHvVkRXIdqOQDnILkZu', 'NEG002', 1.00, '2014-12-28 15:09:50', 2),
('RkWxSDRgVtUEOAZrOGHOQhHvVkRXIdqOQDnILkZu', 'PF001', 1.00, '2014-12-28 15:10:01', 2),
('RkWxSDRgVtUEOAZrOGHOQhHvVkRXIdqOQDnILkZu', 'PF002', 1.00, '2014-12-28 15:10:09', 2),
('sZMRtHrThnMSdquLsPrCYqPCDnIRY0MLGHXIsqIK', 'NEG001', 1.00, '2015-03-13 16:41:49', 0),
('sZMRtHrThnMSdquLsPrCYqPCDnIRY0MLGHXIsqIK', 'PF001', 1.00, '2015-03-13 16:42:02', 0),
('sZMRtHrThnMSdquLsPrCYqPCDnIRY0MLGHXIsqIK', 'PF003', 1.00, '2015-03-13 09:59:25', 0),
('sZMRtHrThnMSdquLsPrCYqPCDnIRY0MLGHXIsqIK', 'PF201', 1.00, '2015-03-13 16:41:39', 0);
-- --------------------------------------------------------
-- Contenu de la table `stockmvt`
INSERT INTO `stockmvt` (`mvtNum`, `mvtCode`, `mvtDate`, `mvtArt`, `mvtQte`, `mvtRefNum`, `mvtMotif`) VALUES
(1, 'RCV', DATE_SUB(CURDATE(), INTERVAL 2 DAY), 'MP001', 2, 'cf-12', ''),
(1, 'RCV', DATE_SUB(CURDATE(), INTERVAL 1 DAY), 'MP001', 1, 'cf-12', ''),
(1, 'RCV', DATE_SUB(CURDATE(), INTERVAL 1 DAY), 'NEG001', 5, 'cf-13', ''),
(1, 'RCV', CURDATE(), 'MP001', 5, 'cf-15', ''),
(1, 'RCV', CURDATE(), 'MP002', 5, 'cf-16', ''),
(1, 'RCV', CURDATE(), 'NEG001', 5, 'cf-17', ''),
(2, 'RCV', CURDATE(), 'NEG002', 5, 'cf-17', ''),
(2, 'RCV', DATE_SUB(CURDATE(), INTERVAL 2 DAY), 'NEG001', 1, 'cf-18', ''),
(2, 'RCV', DATE_SUB(CURDATE(), INTERVAL 2 DAY), 'NEG002', 1, 'cf-18', ''),
(2, 'RCV', DATE_SUB(CURDATE(), INTERVAL 1 DAY), 'NEG001', 5, 'cf-19', ''),
(2, 'RCV', CURDATE(), 'NEG002', 5, 'cf-20', '');
-- --------------------------------------------------------

-- /*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
-- /*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
-- /*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;
